# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://github.com/ajinabraham/njsscan/blob/master/njsscan/rules/semantic_grep/dos/regex_dos.yaml
# hash: e7a0a61
# yamllint enable
---
rules:
- id: "javascript-lang-dos-regex-taint"
  mode: taint
  type: sink
  pattern-sinks:
    - patterns:
        - pattern-either:
          - pattern: |
              /.../.test(<... $REQ ...>)
          - pattern: |
              /.../g.test(<... $REQ ...>)
          - pattern: |
              /.../.exec(<... $REQ ...>)
          - pattern: |
              /.../g.exec(<... $REQ ...>)
  message: |
    Detected a potential Regular Expression Denial of Service (ReDoS) vulnerability in your JavaScript application. 
    ReDoS vulnerabilities occur when user-supplied data is used as input to regular expression operations without proper validation.
    In the detected code pattern, user-controlled data from sources like HTTP requests is being passed directly to regular 
    expression methods like `test()` or `exec()`. If this data contains specially crafted regular expressions, 
    an attacker could potentially cause excessive CPU and memory consumption, leading to a Denial of Service (DoS) condition.
    The impact of a ReDoS vulnerability can be severe, including:
        - Excessive resource consumption (CPU, memory) on the server.
        - Degraded performance or complete unavailability of the application.
        - Potential for Denial of Service (DoS) attacks.

    Ensure that the regex used to compare with user supplied input is safe from regular expression denial of service.

  languages:
  - "javascript"
  severity: "WARNING"
  metadata:
    attack-type: dos
    framework: lang
    kind: code
    owasp: 
    - "A6:2017-Security Misconfiguration"
    - "A05:2021-Security Misconfiguration"
    cwe: "CWE-185"
    shortDescription: "Incorrect regular expression"
    security-severity: "MEDIUM"
    category: "security"
